<?xml version="1.0" ?>
<extension name="phpCairo" version="0.1.0">

	<!-- Summary and other details -->	
	<summary>PHP bindings for Cairo Graphic Library</summary>
	<description>
		This extension offers you object oriented support for Cairo.
	</description>
	<license>php</license>
	<maintainer>
		<user>aki</user>
		<name>Akshat Gupta</name>
  		<email>g.akshat@gmail.com</email>
  		<role>lead</role>
	</maintainer>
	<changelog>
		<release>
   			<version>0.1</version>
   			<date>2006-06-10</date>
   			<state>alpha</state>
   			<notes>First alpha version</notes>
  		</release>
	</changelog>

	<!-- cairo interface -->
	
	<class name="CairoContext">
		<summary>The main drawing class</summary>
		
<!--
		<function name="__construct">
			<proto>void construct(string path)</proto>
			<code></code>
		</function>
-->
		<function name="append_path">
			<proto>void append_path(object p)</proto>
			<code></code>
		</function>

		<function name="arc">
			<proto>void arc(float xc, float yc, float radius, float angle1, float angle2)</proto>
			<code></code>
		</function>

		<function name="arc_negative">
			<proto>void arc_negative(float xc, float yc, float radius, float angle1, float angle2)</proto>
			<code></code>
		</function>

		<function name="clip">
			<proto>void clip()</proto>
			<code></code>
		</function>

		<function name="clip_extents">
			<proto>array clip_extents()</proto>
			<code></code>
		</function>


		<function name="clip_preserve">
			<proto>void clip_preserve()</proto>
			<code></code>
		</function>
        
		<function name="close_path">
		    <proto>void close_path()</proto>
			<code></code>
		</function>
<!-- need to work on the next functin -->
        <function name="copy_clip_rectangle_list">
			<proto>object copy_clip_rectangle_list()</proto>
			<code>/*using iterator in php5.0 to store the 
				list. Pass the array to an iterator during the 
				object definition and jobs done */</code>
		</function>
        
		<function name="copy_page">
			<proto>void copy_page()</proto>
			<code></code>
		</function>

        <function name="copy_path">
			<proto>object copy_path()</proto>
			<code></code>
		</function>

        <function name="copy_path_flat">
			<proto>object copy_path_flat()</proto>
			<code></code>
		</function>

		<function name="curve_to">
			<proto>void curve_to (float x1, float y1, float x2, float y2, float x3, float y3)</proto>
			<code></code>
		</function>

		<function name="device_to_user">
			<proto>array device_to_user(float x, float y)</proto>
			<code></code>
		</function>

		<function name="device_to_user_distance">
			<proto>array device_to_user_distance(float x, float y)</proto>
			<code></code>
		</function>

		<function name="fill">
			<proto>void fill()</proto>
			<code></code>
		</function>

		<function name="fill_extents">
			<proto>array fill_extents()</proto>
			<code></code>
		</function>

		<function name="fill_preserve">
			<proto>void fill_preserve()</proto>
			<code></code>
		</function>

		<function name="font_extents">
			<proto>array font_extents()</proto>
			<code></code>
		</function>

		<function name="get_antialias">
			<proto>int get_antialias()</proto>
			<code></code>
		</function>

		<function name="get_current_point">
			<proto>array get_current_point()</proto>
			<code></code>
		</function>

		<function name="get_dash">
			<proto>array get_dash()</proto>
			<code></code>
		</function>

		<function name="get_dash_count">
			<proto>int get_dash_count()</proto>
			<code></code>
		</function>

		<function name="get_fill_rule">
			<proto>int get_fill_rule()</proto>
			<code></code>
		</function>

		<function name="get_font_face">
			<proto>object get_font_face()</proto>
			<code></code>
		</function>

		<function name="get_font_matrix">
			<proto>object get_font_matrix()</proto>
			<code></code>
		</function>

		<function name="get_font_options">
			<proto>object get_font_options()</proto>
			<code></code>
		</function>

		<function name="get_group_target">
			<proto>object get_group_target()</proto>
			<code></code>
		</function>

		<function name="get_line_cap">
			<proto>int get_line_cap()</proto>
			<code></code>
		</function>

		<function name="get_line_join">
			<proto>int get_line_join()</proto>
			<code></code>
		</function>

		<function name="get_line_width">
			<proto>float get_line_width()</proto>
			<code></code>
		</function>

		<function name="get_matrix">
			<proto>object get_matrix()</proto>
			<code></code>
		</function>

		<function name="get_matrix_limit">
			<proto>float get_matrix_limit()</proto>
			<code></code>
		</function>

		<function name="get_operator">
			<proto>int get_operator()</proto>
			<code></code>
		</function>

		<function name="get_scaled_font">
			<proto>object get_scaled_font()</proto>
			<code></code>
		</function>

		<function name="get_source">
			<proto>object get_source()</proto>
			<code></code>
		</function>
<!-- -->
		<function name="get_target">
			<proto>object get_target()</proto>
			<code></code>
		</function>

		<function name="get_tolerance">
			<proto>float get_tolerance()</proto>
			<code></code>
		</function>

		<function name="glyph_extents">
			<proto>array get_extents(object obj[,int num])</proto>
			<code>/*This might be a prob*/</code>
		</function>

		<function name="glyph_path">
			<proto>void glyph_pat(object obh[,int num])</proto>
			<code></code>
		</function>

		<function name="has_current_point">
			<proto>bool has_current_point()</proto>
			<code>/* ONLY for CAIRO 1.6 */</code>
		</function>


		<function name="identity_matrix">
			<proto>void identity_matrix()</proto>
			<code></code>
		</function>

		<function name="in_fill">
			<proto>bool in_fill(float x, float y)</proto>
			<code></code>
		</function>

		<function name="in_stroke">
			<proto>bool in_stroke(float x, float y)</proto>
			<code></code>
		</function>

		<function name="line_to">
			<proto>void line_to(float x, float y)</proto>
			<code></code>
		</function>

		<function name="mask">
			<proto>void mask(object p)</proto>
			<code></code>
		</function>

		<function name="mask_surface">
			<proto>void mask_surface(object s[,float surface_x, float surface_y])</proto>
			<code></code>
		</function>

		<function name="move_to">
			<proto>void move_to(float x, float y)</proto>
			<code></code>
		</function>

		<function name="new_path">
			<proto>void new_path()</proto>
			<code></code>
		</function>

		<function name="new_sub_path">
			<proto>void new_sub_path()</proto>
			<code></code>
		</function>

		<function name="paint">
			<proto>void paint()</proto>
			<code></code>
		</function>

		<function name="paint_with_alpha">
			<proto>void paint_with_alpha(float alpha)</proto>
			<code></code>
		</function>

		<function name="path_extents">
			<proto>array path_extents([object path])</proto>
			<code>/* ONLY for CAIRO 1.6 */</code>
		</function>

		<function name="pop_group">
			<proto>object pop_group()</proto>
			<code></code>
		</function>

		<function name="pop_group_to_source">
			<proto>void pop_group_to_source()</proto>
			<code></code>
		</function>

		<function name="push_group">
			<proto>void push_group()</proto>
			<code></code>
		</function>

		<function name="push_group_with_content">
			<proto>void push_group_with_content(int content)</proto>
			<code></code>
		</function>

		<function name="rectangle">
			<proto>void rectangle(float x, float y, float width, float height)</proto>
			<code></code>
		</function>

		<function name="rel_curve_to">
			<proto>void rel_curve_to(float x1, float y1, float x2, float y2, float x3, float y3)</proto>
			<code></code>
		</function>

		<function name="rel_line_to">
			<proto>void rel_line_to(float x, float y)</proto>
			<code></code>
		</function>

		<function name="rel_move_to">
			<proto>void rel_move_to(float x, float y)</proto>
			<code></code>
		</function>

		<function name="reset_clip">
			<proto>void reset_clip()</proto>
			<code></code>
		</function>

		<function name="restore">
			<proto>void restore()</proto>
			<code></code>
		</function>

		<function name="rotate">
			<proto>void rotate(float angle)</proto>
			<code></code>
		</function>

		<function name="save">
			<proto>void save()</proto>
			<code></code>
		</function>

		<function name="scale">
			<proto>void scale(float x, float y)</proto>
			<code></code>
		</function>

		<function name="select_font_face">
			<proto>void select_font_face(object obj[, int slant, int weight])</proto>
			<code></code>
		</function>

		<function name="set_antialias">
			<proto>void set_antialias([int antialias])</proto>
			<code></code>
		</function>

		<function name="set_dash">
			<proto>void set_dash(object dashes [,float offset])</proto>
			<code></code>
		</function>

		<function name="set_fill_rule">
			<proto>void set_fill_rule(int fill_rule)</proto>
			<code></code>
		</function>

		<function name="set_font_face">	
			<proto>void set_font_face([object obj])</proto>
			<code></code>
		</function>

		<function name="set_font_matrix">
			<proto>void set_font_matrix(object matrix)</proto>
			<code></code>
		</function>

		<function name="set_font_options">
			<proto>void set_font_options(object options)</proto>
			<code></code>
		</function>

		<function name="set_font_size">
			<proto>void set_font_size(float size)</proto>
			<code></code>
		</function>

		<function name="set_line_cap">
			<proto>void set_line_cap(int line_cap)</proto>
			<code></code>
		</function>

		<function name="set_line_join">
			<proto>void set_line_join(int line_join)</proto>
			<code></code>
		</function>

		<function name="set_line_width">
			<proto>void set_line_width(float width)</proto>
			<code></code>
		</function>

		<function name="set_matrix">
			<proto>void set_matrix(object matix)</proto>
			<code></code>
		</function>

		<function name="set_miter_limit">
			<proto>void set_miter_limit(float limit)</proto>
			<code></code>
		</function>

		<function name="set_operator">
			<proto>void set_operator(int op)</proto>
			<code></code>
		</function>

		<function name="set_source">
			<proto>void set_source(object p)</proto>
			<code></code>
		</function>

		<function name="set_source_rgb">
			<proto>void set_source_rgb(float red, float green, float blue)</proto>
			<code></code>
		</function>

		<function name="set_source_rgba">
			<proto>void set_source_rgba(float red, float green, float blue [,float alpha])</proto>
			<code></code>
		</function>

		<function name="set_source_surface">
			<proto>void set_source_surface(object surface [,float x, float y])</proto>
			<code></code>
		</function>

		<function name="set_tolerance">
			<proto>void set_tolerance(float tolerance)</proto>
			<code></code>
		</function>

		<function name="show_glyphs">
			<proto>void show_glyphs(object glyphs [,int num_glyphs])</proto>
			<code></code>
		</function>

		<function name="show_page">
			<proto>void show_page()</proto>
			<code></code>
		</function>

		<function name="show_text">
			<proto>void show_text(object obj)</proto>
			<code></code>
		</function>

		<function name="stroke">
			<proto>void stroke()</proto>
			<code></code>
		</function>

		<function name="stroke_extents">
			<proto>array stroke_extents()</proto>
			<code></code>
		</function>

		<function name="stroke_preserve">
			<proto>void stroke_preserve()</proto>
			<code></code>
		</function>

		<function name="text_extents">
			<proto>array text_extents(object extents)</proto>
			<code></code>
		</function>

		<function name="text_path">
			<proto>void text_path(object obj)</proto>
			<code></code>
		</function>
		
		<function name="transform">
			<proto>void transform(object matrix)</proto>
			<code></code>
		</function>

		<function name="translate">
			<proto>void translate(float tx, float ty)</proto>
			<code></code>
		</function>

		<function name="user_to_device">
			<proto>array user_to_device(float x, float y)</proto>
			<code></code>
		</function>

		<function name="user_to_device_distance">
			<proto>array user_to_device_distance(float dx, float dy)</proto>
			<code></code>
		</function>

	</class>

	<class name="CairoFontFace">
		<function name="__construct">
			<proto>void construct()</proto>
			<code>/* not allowede to create an object directly*/</code>
		</function>

		<function name="__destruct">
			<proto>void destruct()</proto>
			<code></code>
		</function>

	</class>
	

	<class name="CairoFontOptions">
		<function name="__construct">
			<proto>void construct()</proto>
			<code></code>
		</function>

		<function name="get_antialias">
			<proto>int get_antialias()</proto>
			<code></code>
		</function>

		<function name="get_hint_metrics">
			<proto>int get_hint_metrics()</proto>
			<code></code>
		</function>

		<function name="get_hint_style">
			<proto>int get_hint_style()</proto>
			<code></code>
		</function>

		<function name="get_subpixel_order">
			<proto>int get_subpixel_order()</proto>
			<code></code>
		</function>

		<function name="set_antialias">
			<proto>void set_antialias([int aa])</proto>
			<code></code>
		</function>

		<function name="set_hint_metrics">
			<proto>void set_hint_metrics([int hm])</proto>
			<code></code>
		</function>

		<function name="set_hint_style">
			<proto>void set_hint_style([int hs])</proto>
			<code></code>
		</function>
		
		<function name="set_subpixel_order">
			<proto>void set_subpixel_order([int so])</proto>
			<code></code>
		</function>
	</class>

	<class name="CairoMatrix">
		
		<function name="__construct">
			<proto>void construct([float xx, float yx, float xy, float yy, float x0, float y0])</proto>
			<code></code>
		</function>

		<function name="init_rotate" access="private">
			<proto>object inti_rotate(float radians)</proto>
			<code></code>
		</function>

		<function name="invert">
			<proto>void invert()</proto>
			<code></code>
		</function>

		<function name="multiply">
			<proto>object multiply(object o2)</proto>
			<code></code>
		</function>

		<function name="rotate">
			<proto>void rotate(float radians)</proto>
			<code></code>
		</function>

		<function name="scale">
			<proto>void scale(float sx, float xy)</proto>
			<code></code>
		</function>

		<function name="transform_distance">
			<proto>array transform_distance(float dx, float dy)</proto>
			<code></code>
		</function>

		<function name="transform_point">
			<proto>array transform_point(float x, float y)</proto>
			<code></code>
		</function>

		<function name="translate">
			<proto>void translate(float tx, float ty)</proto>
			<code></code>
		</function>

		<!--Some more functions given in pyCairo ... depends on need -->
	</class>

	<class name="CairoPattern">
		
		<function name="__construct">
			<proto>void contruct()</proto>
			<code></code>
		</function>

		<function name="get_matrix">
			<proto>object get_matrix()</proto>
			<code></code>
		</function>

		<function name="set_matrix">
			<proto>void set_matrix(object m)</proto>
			<code></code>
		</function>

	</class>

	<class name="CairoGradient" extends="CairoPattern">

		<function name="__contruct">
			<proto>void construct()</proto>
			<code></code>
		</function>

		<function name="add_color_stop_rgb">
			<proto>void add_color_stop_rgb(float offset, float red, float green, float blue)</proto>
			<code></code>
		</function>

		<function name="add_color_stop_rgba">
			<proto>void add_color_stop_rgba(float offset, float red, float green, float blue, float alpha)</proto>
			<code></code>
		</function>

	</class>

	<class name="CairoLinearGradient" extends="CairoGradient">
		
		<function name="__construct">
			<proto>void construct(float x0, float y0, float x1, float y1)</proto>
			<code></code>
		</function>

		<function name="get_linear_points">
			<proto>array get_linear_points()</proto>
			<code></code>
		</function>

	</class>

	<class name="CairoRadialGradient" extends="CairoGradient">
		
		<function name="__constuct">
			<proto>void construct(float cx0, float cy0, float radius0, float cx1, float cy1, float radius1)</proto>
			<code></code>
		</function>

		<function name="get_radial_circles">
			<proto>array get_radial_circles()</proto>
			<code></code>
		</function>
	
	</class>

	<class name="CairoSolidPattern" extends="CairoPattern">
		
		<function name="__construct">
			<proto>void construct(float r, float g, float b [, float a])</proto>
			<code></code>
		</function>

		<function name="get_rgba">
			<proto>array get_rgba()</proto>
			<code></code>
		</function>

	</class>

	<class name="CairoSurfacePattern" extends="CairoPattern">
		
		<function name="__construct">
			<proto>void construct(object s)</proto>
			<code></code>
		</function>

		<function name="get_extend">
			<proto>int get_extend()</proto>
			<code></code>
		</function>
		
		<function name="get_filter">
			<proto>int get_filter()</proto>
			<code></code>
		</function>

		<function name="get_surface">
			<proto>object get_surface()</proto>
			<code></code>
		</function>

		<function name="set_extend">
			<proto>void set_extend(int extend)</proto>
			<code></code>
		</function>

		<function name="set_filter">
			<proto>void set_filter(int filter)</proto>
			<code></code>
		</function>

	</class>

	<class name="CairoScaledFont">
		
		<function name="__construct">
			<proto>void construct(object ff, object mx1, object mx2, object fo)</proto>
			<code></code>
		</function>

		<function name="extents">
			<proto>array extents()</proto>
			<code></code>
		</function>

		<function name="get_font_face">
			<proto>object get_font_face()</proto>
			<code></code>
		</function>

		<function name="text_extents">
			<proto>array text_extents(string str)</proto>
			<code></code>
		</function>

	</class>
	
	<class name="CairoSurface">
		
		<function name="__construct">
			<proto>void construct()</proto>
			<code></code>
		</function>

		<function name="create_similar">
			<proto>object create_similar(int content, int width, int height)</proto>
			<code></code>
		</function>

		<function name="finish">
			<proto>void finish()</proto>
			<code></code>
		</function>

		<function name="flush">
			<proto>void flush()</proto>
			<code></code>
		</function>

		<function name="get_content">
			<proto>int get_content()</proto>
			<code></code>
		</function>

		<function name="get_device_offset">
			<proto>array get_device_offset()</proto>
			<code></code>
		</function>

		<function name="get_font_options">
			<proto>object get_font_options()</proto>
			<code></code>
		</function>

		<function name="mark_dirty_rectangle">
			<proto>void mark_dirty_rectangle([int x, int y, int width, int height])</proto>
			<code></code>
		</function>

		<function name="set_device_offset">
			<proto>void set_device_offset(float x_offset, float y_offset)</proto>
			<code></code>
		</function>

		<function name="set_fallback_resolution">
			<proto>void set_fallback_resolution(float x_ppi, float y_ppi)</proto>
			<code></code>
		</function>

		<function name="write_to_png">
			<proto>void write_to_png(string file)</proto>
			<code></code>
		</function>

	</class>

	<class name="CairoImageSurface" extends="CairoSurface">
		
		<function name="__construct">
			<proto>void construct(int format, int widthm, int height)</proto>
			<code></code>
		</function>

		<function name="create_from_data" access="private">
			<proto>object create_from_data(object obj, int format, int width, int height [, int stride])</proto>
			<code></code>
		</function>

		<function name="create_from_png" access="private">
			<proto>object create_from_png(string file)</proto>
			<code></code>
		</function>

		<function name="get_data">
			<proto>string get_data()</proto>
			<code></code>
		</function>

		<function name="get_format">
			<proto>int get_format()</proto>
			<code></code>
		</function>

		<function name="get_height">
			<proto>int get_height()</proto>
			<code></code>
		</function>

		<function name="get_stride">
			<proto>int get_stride()</proto>
			<code></code>
		</function>

		<function name="get_width">
			<proto>int get_width()</proto>
			<code></code>
		</function>

	
	</class>

	<class name="CairoPDFSurface" extends="CairoSurface">
	
		<function name="__construct">
			<proto>void construct(string file, float wpts, float hpts)</proto>
			<code></code>
		</function>

		<function name="set_size">
			<proto>void set_size(float wptd, float hpts)</proto>
			<code></code>
		</function>

	</class>

	<class name="CairoPSSurface" extends="CairoSurface">

		<function name="__construct">
			<proto>void construct(string file, float wpts, float hpts)</proto>
			<code></code>
		</function>

		<function name="dsc_begin_page_setup">
			<proto>void dsc_begin_page_setup()</proto>
			<code></code>
		</function>

		<function name="dsc_begin_setup">
			<proto>void dsc_begin_setup()</proto>
			<code></code>
		</function>

		<function name="dsc_comment">
			<proto>void dsc_comment()</proto>
			<code></code>
		</function>

		<function name="get_levels">
			<proto>array get_levels()</proto>
			<code>/* ONLY for CAIRO 1.6 </code>
		</function>

		<function name="get_level_string">
			<proto>string get_level_string()</proto>
			<code>/* ONLY for CAIRO 1.6*/</code>
		</function>

		<function name="restrict_to_level">
			<proto>void restrict_to_level(int level)</proto>
			<code>/* ONLY for CAIRO 1.6 */</code>
		</function>

		<function name="set_eps">
			<proto>void set_eps()</proto>
			<code>/* ONLY for CAIRO 1.6 */</code>
		</function>

		<function name="set_size">
			<proto>void set_size(float wpts, float hpts)</proto>
			<code></code>
		</function>

	</class>

	<class name="CairoQuartzSurface" extends="CairoSurface">
		
		<function name="__construct">
			<proto>void construct(float wpixels, float hpixels [, int format])</proto>
			<code></code>
		</function>
	</class>

	<class name="CairoSVGSurface" extends="CairoSurface">
		
		<function name="__construct">
			<proto>void construct(string file, float wpts, float hpts)</proto>
			<code></code>
		</function>

	</class>

	<class name="CairoWin32Surface" extends="CairoSurface">
		
		<function name="__construct">
			<proto>void construct(int hdc)</proto>
			<code></code>
		</function>

	</class>

	<class name="CairoXlibSurface" extends="CairoSurface">

		<function name="__construct">
			<proto>void construct()</proto>
			<code></code>
		</function>

		<function name="get_depth">
			<proto>int get_depth()</proto>
			<code></code>
		</function>

		<function name="get_height">
			<proto>int get_height()</proto>
			<code></code>
		</function>

		<function name="get_width">
			<proto>int get_width()</proto>
			<code></code>
		</function>

	</class>

	<class name="CairoException" extends="Exception">
		
	</class>
	
	<function name="cairo_version">
		<proto>int cairo_version()</proto>
		<code></code>
	</function>

	<function name="cairo_version_string">
		<proto>string cairo_version_string()</proto>
		<code></code>
	</function>


</extension>
